/*
 * MosP - Mind Open Source Project    http://www.mosp.jp/
 * Copyright (C) MIND Co., Ltd.       http://www.e-mind.co.jp/
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */
package jp.mosp.system.action;

import java.util.Date;
import java.util.List;

import jp.mosp.common.CommonConst;
import jp.mosp.common.common.BaseVo;
import jp.mosp.common.common.MospConst;
import jp.mosp.common.common.MospException;
import jp.mosp.common.common.MospUtility;
import jp.mosp.common.dao.MosPUserDao;
import jp.mosp.common.dto.CmUserDto;
import jp.mosp.common.utils.DateUtil;
import jp.mosp.kintai.common.action.MosPHumanAction;
import jp.mosp.kintai.common.dto.MKihonDto;
import jp.mosp.system.vo.FirstHumanAccountCardVo;

/**
 * @author yoshida
 *
 */
public class FirstHumanAccountCardAction extends MosPHumanAction {
	
	// コマンド
	private static final String	CMD_FIRST_HUMAN_ACCOUNT_CARD_SHOW	= "S2410";
	private static final String	CMD_FIRST_HUMAN_ACCOUNT_CARD_INSERT	= "S2417";
	

	/**
	 * コンストラクタ
	 */
	public FirstHumanAccountCardAction() {
		super();
	}
	
	/**
	 * アクション
	 */
	public void action() throws Exception {
		// VOの取得
		prepareVo(false);
		// 初期処理
		init();
		// コマンド毎の処理
		if (cmd.equals(CMD_FIRST_HUMAN_ACCOUNT_CARD_SHOW)) {
			show();
		} else if (cmd.equals(CMD_FIRST_HUMAN_ACCOUNT_CARD_INSERT)) {
			// 新規登録
			insert();
		} else {
			throw new MospException(MospConst.EX_CMD_INVALID);
		}
	}
	
	@Override
	protected BaseVo getSpecificVo() {
		return new FirstHumanAccountCardVo();
	}
	
	@Override
	protected void init() throws Exception {
		// DBコネクション取得
		getConnection();
		// SYSTEM権限確認
		confirmSystemAuth();
		// プルダウンのセット
		FirstHumanAccountCardVo vo = (FirstHumanAccountCardVo)getVo();
		vo.aryPltOfficeAll = getOfficeArrayAll();
		vo.aryPltSectionAll = getSectionArrayAll();
		vo.aryPltPosition = getPositionPltArray();
		// 事業所、所属、役職が一件も登録されていない場合
		if (vo.aryPltOfficeAll.length == 0 || vo.aryPltPosition.length == 0 || vo.aryPltSectionAll.length == 0) {
			// メッセージ設定
			vo.setMessage(getMessage(MospConst.MSG_NO_CODE, ""));
		}
	}
	
	@Override
	protected void show() throws Exception {
		// 初期値表示
		setMode();
	}
	
	@Override
	protected void insert() throws Exception {
		FirstHumanAccountCardVo vo = (FirstHumanAccountCardVo)getVo();
		vo.setParams(request);
		// パラメータの妥当性確認
		vo.validate();
		// マスタデータ存在確認
		chkDuplicate(humanBasisDao().findForKey(vo.getTxtKCode()));
		// 登録処理
		regist();
		// コミット
		commit();
		// 一覧表示へ
		setNextCmd(AccountMasterListAction.CMD_ACCOUNT_MASTER_LIST_RE_SEARCH);
		// サーブレットへ転送
		setUrl(MospConst.URL_SRV);
	}
	
	/**
	 * 登録処理
	 * @throws Exception 例外処理が発生した場合
	 */
	private void regist() throws Exception {
		FirstHumanAccountCardVo vo = (FirstHumanAccountCardVo)getVo();
		// DTO準備
		mKihonDto = new MKihonDto();
		mKihonDto.setKCode(vo.getTxtKCode());
		mKihonDto.setSimei(vo.getTxtUserName());
		mKihonDto.setSCode(vo.getPltSection());
		mKihonDto.setYCode(vo.getPltPosition().split(CommonConst.STR_TIME_SEPARATOR)[0]);
		mKihonDto.setTokyu(vo.getPltPosition().split(CommonConst.STR_TIME_SEPARATOR)[1]);
		mKihonDto.setJCode(vo.getPltOffice());
		mKihonDto.setKnKubun(String.valueOf(CommonConst.RETIREMENT_FLAG_OFF));
		// 入社日を登録日に設定
		mKihonDto.setNyDate(DateUtil.convDateToInteger(DateUtil.getSystemDate()));
		// 存在確認
		String message = "";
		if (!chkExistDto(humanBasisDao().findForUpdate(mKihonDto.getKCode()))) {
			// 新規登録
			humanBasisDao().insert(mKihonDto);
			// 人事基本情報取得
			findHumanBasisInfo(mKihonDto.getKCode(), false);
			// ユーザー情報取得
			MosPUserDao dao = part().mospuser().getMosPUserDao();
			// ユーザ処理
			if (!chkExistDto(dao.findForUpdate(mKihonDto.getKCode()))) {
				// ユーザーの作成
				CmUserDto cmUserDto = new CmUserDto();
				cmUserDto.setUserId(mKihonDto.getKCode());
				cmUserDto.setPassword(MospUtility.getDigest(MospUtility.getDigest(mKihonDto.getKCode())));
				cmUserDto.setKCode(mKihonDto.getKCode());
				cmUserDto.setUserName(mKihonDto.getSimei());
				cmUserDto.setAuthority(CommonConst.AUTHORITY_HUMAN);
				cmUserDto.setChangePass(new Date());
				cmUserDto.setDataLevel(CommonConst.DATA_DEFAULT_LEVEL);
				// 登録
				dao.insert(cmUserDto);
				message = getMessage(MospConst.MSG_INSERT, "");
			} else {
				message = getMessage(MospConst.MSG_DUPLICATE, "");
			}
		} else {
			message = getMessage(MospConst.MSG_DUPLICATE, "");
		}
		// メッセージ設定
		setMessage(message);
	}
	
	/**
	 * モード設定
	 * @throws Exception 例外処理が発生した場合
	 */
	private void setMode() throws Exception {
		FirstHumanAccountCardVo vo = (FirstHumanAccountCardVo)getVo();
		List<CmUserDto> listHuman = part().mospuser().getMosPUserDao().findAllMosPUser();
		// HUMAN権限確認
		boolean hasAuth = false;
		String[][] aryHuman = getConfArray(CommonConst.CONF_ID_HUMAN);
		for (CmUserDto dto : listHuman) {
			for (String[] ary : aryHuman) {
				if (ary[0].equals(dto.getAuthority())) {
					hasAuth = true;
					break;
				}
			}
		}
		if (hasAuth) {
			// メッセージ設定
			vo.setMessage(getMessage(MospConst.MSG_DUPLICATE, ""));
			vo.setMode(FirstHumanAccountCardVo.MODE_VIEW);
		} else {
			vo.setMode(FirstHumanAccountCardVo.MODE_INSERT);
		}
	}
	
}
